;
;Program name : CONSTAT.ASM
;Author       : James Whorton
;Date written : 09/29/84
;
;This is the display driver for the CONSOLE RSX module.
;To use it, install CONSOLE, then run this program for a
;display of console call statistics.
;
;equates
;
warm:	equ	0
bdos:	equ	5
fcb:	equ	05Ch		;FCB address
cin:	equ	1
cout:	equ	2
cr:	equ	13
lf:	equ	10
request:equ	255		;This is the request character that
				;triggers the CONSOLE RSX and produces
				;a display. It must be set to the same
				;value as CONSOLE to work properly.
;
;Program starts here
;
	org	0100h
;
	lxi	h,signon	;identify self
	call	ilprt
	lxi	h,header	;set up table heading
	call	ilprt
	mvi	a,request	;load value into FCB to
	sta	fcb		;trigger CONSOLE RSX upon calling
	mvi	c,cout		;console out function
	mvi	e,0
	call	bdos
	lxi	h,endlin	;finish and exit
	call	ilprt
	jmp	warm
;
;inline print routine
;
ilprt:	equ	$
	push	psw
	push	h
	push	d
	push	b
;
ilplp:	mov	e,m
	mvi	c,cout
	push	h
ilplp1:	call	bdos
	pop	h
	inx	h
	mov	a,m
	ora	a
	jnz	ilplp
	pop	b
	pop	d
	pop	h
	pop	psw
	ret
;
; Data area
;
signon:	db	cr,lf,'CONSTAT v1.0        James Whorton        09/29/84'
	db	cr,lf,'Table of frequency of console BDOS requests since'
	db	cr,lf,'installation or last check.'
	db	cr,lf,0
header:	db	cr,lf,lf,'Function #   Description    # of requests'
	db	cr,lf,'_________________________________________',0
;
endlin:	db	cr,lf,lf,0
;
	end
#   Description    # of requests'
	db	cr,lf,'________________